// Rate Calculator plugin for jQuery

(function($){
	$.fn.rateCalc = function(options) 
	{
		var obj = $(this);
		var threshold = 0;
		var toolTip = 'test';
		
		var defaults = {
			  min_days: 1
			, max_days: 30
			, default_sum: 4000
			, default_days: 15
			, count_done: {100:1,150:2}
			, prolong_days: new Array(7,14,30)
			, day_step: 1
			, description_sum: 'description_sum'
			, subtext_sum: 'subtext_sum'
			, description_day: 'description_day'
			, subtext_day: 'subtext_day'
			, submit_string:'' 	
		};
		var options = $.extend(defaults, options);
		
		var fixed_tab = 0;
		
		return this.each( function(){
			$(obj).html('');
			
			var count = 0;
			for( var key in options.count_done )
			{
				if( count == 0 )
					threshold = parseInt(key);
				count++;
			}
			
			
			generate_body( $(obj) );
			
			toolTip = $(obj).find(".rateCalc_ToolTip");
			
			$(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit").slider(
				{
					animate:true
					,range: "min"
					,min: options.min_sum
					,max: options.max_sum
					,count_done: options.count_done
					,value: options.default_sum
					,name: "summ"
					,step: options.sum_step
				}
			).bind('slide', exec_slide );
			$(obj).find(".rateCalc_DayBody_Slider_SliderBody .rateCalc_SliderInit").slider(
				{
					animate:true
					,range: "min"
					,min: options.min_days
					,max: options.max_days
					,value: options.default_days
					,name: "days"
				}
			).bind('slide', exec_slide );
			
			//$(obj).find("a.increment").bind( "click", increment_slider );
			//$(obj).find("a.decrement").bind( "click", decrement_slider );
			
			$(".rateCalc_SubmitButton").bind("click", sumbit_loan);
			
			$(obj).find("input.sliderInfo").bind( "keydown", disableEnterKey ); // this shit will just check if it is integer
			$(obj).find("input.sliderInfo").bind( "keyup", check_int_value ); // this shit will just check if it is integer			
			$(obj).find("input.sliderInfo").bind( "blur", update_slider ); // this will actually check amount
			$(obj).find("input.sliderInfo").bind( "click", select_all ); 
			$(obj).find(".RightSliderAddon").bind( "click", select_max_value); 
			$(obj).find(".LeftSliderAddon").bind( "click", select_min_value); 
			
			
			$(obj).find(".ui-slider-handle").bind( "mousedown", check_the_sum_is_right); // 
			
			update_info_line( $(obj).find(".rateCalc_DayBody .rateCalc_SliderInit") );
		
			//$("#calc_tabs").tabs();
			
			
			$("a#splus").mousehold(100, function(i){
				increment_slider(0, this);
			});

			$("a#dplus").mousehold(100, function(i){
				increment_slider(0, this);
			});

			$("a#sminus").mousehold(100, function(i){
				decrement_slider(0, this);
			});

			$("a#dminus").mousehold(100, function(i){
				decrement_slider(0, this);
			});

/*
			if (!options.logged_in)
				$("#stamp").css("background",'url(/js/rateCalc/stamps.png) left top');
			else
			{	
				if (options.num_of_contracts == 0)
				{
					$("#stamp").css("background",'url(/js/rateCalc/stamps.png) left top');
				}
			}
			
			$("a#c_tab_1").click(function(e){
				
				fixed_tab = 0;
				var target_slder = $(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit");
				
				//if ($(target_slder).slider('value') <= options.first_loan_treshold) return true;
				
				$("#stamp").css("background",'url(/js/rateCalc/stamps.png) 0px 0px');
				
				$(target_slder).slider( "option", "max", options.max_sum);
				
				$("#sum_input").val(parseInt(options.first_loan_treshold));
				$(target_slder).slider( 'value', options.first_loan_treshold );
				update_info_line(null);
			});

			$("a#c_tab_2").click(function(e){
				
				fixed_tab = 1;
				var target_slder = $(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit");
				
				$("#stamp").css("background",'none');								

				$(target_slder).slider( "option", "max", options.max_sum);
				
				//$("#sum_input").val(parseInt(options.second_loan_treshold));
				$("#sum_input").val(parseInt(3000));
				//$(target_slder).slider( 'value', options.second_loan_treshold );
				$(target_slder).slider( 'value', parseInt(3000) );
				update_info_line(null);
			});
*/			
		});
		
		
		function isArray(obj) {
			   if (obj.constructor.toString().indexOf("Array") == -1)
			      return false;
			   else
			      return true;
			}
		
		
		function exec_slide( event, ui )
		{
			var sliderTr = $(ui.handle).parent().parent().parent();
			var slider = $(sliderTr).find("input.sliderInfo");
			$(slider).val( ui.value );
			
			var slider_obj = $(event.target).parent().parent().find(".rateCalc_SliderInit");			
			var name = $(slider_obj).slider("option", "name");

			if (name == "summ")
			{
				//el.innerHTML = sum_hints[Number((ui.value - 1) >=150)]; 
				//if (ui.value > 150)
				var wrapper = $(obj);
				var infoLine = $(wrapper).find(".rateCalc_InfoLine1");
				$(infoLine).html(options.sum_hints[Number((ui.value - 1) >=150)]);
				
			}
			
			
			/*
			for( var key in options.count_done )
			{
				if( ui.value >= threshold )
				{
					if( ui.value >= parseInt(key) )
						initToolTip( 'show', options.count_done[key] );
				}
				else
					initToolTip( 'hide', 0 );
			}
			*/
			
			update_info_line( ui.handle );
			//$("#test").html( inspect( ui.handle, 3 ) ); //$(slider).slider("options","min")
		}
		
		function update_info_line( slider )
		{
			//var wrapper = $(slider).parent().parent().parent().parent().parent().parent();
			var wrapper = $(obj);
			var initial = parseInt($(wrapper).find(".rateCalc_SumBody_Slider_Info input.sliderInfo").val());
			var days = parseInt($(wrapper).find(".rateCalc_DayBody_Slider_Info input.sliderInfo").val());
			//var comission = RoundFixed( (((initial / 100) * (465 / 365) * days) + 1), 2);
			var comission= 0;
			
			var tmp_initial = initial;
			initial = initial / options.formula_multiplyer;  
			//Lets figure out where to get this mutiplater
			if (!(isArray(options.comm_mult)))
			{
				options_comm_mult = options.comm_mult;
				options_prolong_mult = options.prolong_mult;
			}
			else
			{
				if (fixed_tab == 0)
				{
					if (Number((tmp_initial) <= options.first_loan_treshold))
						{
							options_comm_mult = options.comm_mult[0]; 
							options_prolong_mult = options.prolong_mult[0];
						}
					if (Number((tmp_initial) > options.first_loan_treshold))
					{
	
							options_comm_mult = options.comm_mult[1]; 
							options_prolong_mult = options.prolong_mult[1];										

					}
				}
				else
				{
					options_comm_mult = options.comm_mult[fixed_tab]; 
					options_prolong_mult = options.prolong_mult[fixed_tab];
				}
					
			}
			if (initial <= 50) {
				// (0,2*s_sum – 0,2*s_sum*0,025*(30-s_term))-1/(s_sum^2*s_term)
				comission = RoundFixed( (((0.2*initial - 0.2*initial*0.025*(30-days))-1/(initial*initial*days) + (50-initial)*0.04) * options.formula_multiplyer) * options_comm_mult, 0);
				//(0,265 – s_sum * 0,0002) * s_sum- (0,24 – 0,0001 * s_sum) * s_sum * 0,025 * (30 – s_term) + (50 - s_sum)*0,04
				// options.prolong_days[x]
				prolong1 = RoundFixed( ((0.265 - initial * 0.0002) * initial - (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[0]) + (50 - initial)* 0.034)*options.formula_multiplyer * options_prolong_mult, 0);
				prolong2 = RoundFixed( ((0.265 - initial * 0.0002) * initial - (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[1]) + (50 - initial)* 0.034)*options.formula_multiplyer * options_prolong_mult, 0);
				prolong3 = RoundFixed( ((0.265 - initial * 0.0002) * initial - (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[2]) + (50 - initial)* 0.034)*options.formula_multiplyer * options_prolong_mult, 0);
			}
			else {
				//(0,2*s_sum – 0,2*s_sum*0,025*(30-s_term))-1/(s_sum^2*s_term) + (50-s_sum)*0,04
				comission = RoundFixed((((0.2*initial - 0.2*initial*0.025*(30-days))-1/(initial*initial*days)) * options.formula_multiplyer) * options_comm_mult, 0);
				// (0,265 – s_sum * 0,0002) * s_sum- (0,24 – 0,0001 * s_sum) * s_sum * 0,025 * (30 – s_term)
				prolong1 = RoundFixed( ((0.265 - initial * 0.0002) * initial- (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[0])) * options.formula_multiplyer * options_prolong_mult, 0);
				prolong2 = RoundFixed( ((0.265 - initial * 0.0002) * initial- (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[1])) * options.formula_multiplyer * options_prolong_mult, 0);
				prolong3 = RoundFixed( ((0.265 - initial * 0.0002) * initial- (0.24 - 0.0001 * initial) * initial * 0.025 * (30 - options.prolong_days[2])) * options.formula_multiplyer * options_prolong_mult, 0);
				
			};
			
			// return value back
			initial = tmp_initial;
			
			var infoLine = $(wrapper).find(".rateCalc_InfoLine1");
			$(infoLine).html(options.sum_hints[Number((initial - 1) >=options.second_loan_treshold)]);
			
			if (options.logged_in)
			{
				/* Do nothing as we do not have any tabs
				var $tabs = $('#calc_tabs').tabs();
				if (fixed_tab ==0 )
				{
					if (Number((initial) <= options.first_loan_treshold))
					{
						$tabs.tabs('select', 0);
						$("#stamp").css("background",'url(/js/rateCalc/stamps.png) 0px 0px');
					}
					if (Number((initial) > options.first_loan_treshold))
					{
						$tabs.tabs('select', 1);
						$("#stamp").css("background",'none');

					}
				}
				*/
				
				if (options.total_amount_last_12_months >=0 ) // No agreement signed
				{
					//alert(Number((initial + options.total_amount_last_12_months)));
					if (Number((initial + Number(options.total_amount_last_12_months)) >= options.total_loans_amount_per_year))
					{
						$("#agreement_reminder").css('visibility',"visible");

					}
					else
					{
						$("#agreement_reminder").css('visibility',"hidden");
					}
				}
			}
			
			if(initial <= options.first_loan_treshold) $(infoLine).html('&nbsp;');

			var prolongLine1 = $(wrapper).find(".rateCalc_prolongLine1");
			var prolongLine2 = $(wrapper).find(".rateCalc_prolongLine2");
			var prolongLine3 = $(wrapper).find(".rateCalc_prolongLine3");
			
			var infoLine2 = $(wrapper).find(".rateCalc_InfoLine2");
			var infoLine3 = $(wrapper).find(".rateCalc_InfoLine3");
			var infoLine4 = $(wrapper).find(".rateCalc_InfoLine4");
			
			// set all commision related data
			//var new_text = options.info_line_string.replace('%INITIAL%', initial).replace('%COMISSION%', comission).replace('%TOTAL%', RoundFixed(parseInt(initial) + parseFloat(comission), 2));
			var new_text = options.info_line_string2.replace('%INITIAL%', initial).replace('%COMISSION%', comission);
			$(infoLine2).html( new_text );
			
			var returnmon = parseInt(date("m", strtotime("+" + days + " days")), 10);			
			var new_date  = date("j", strtotime("+" + days + " days")) + " " + options.months[returnmon - 1];
						
			if (options.lang == 'ru') new_date = new_date.replace(/\./,'');

			$(infoLine3).html(  options.info_line_string3.replace('%RETURNDATE%', new_date) );
			
			var new_text = options.info_line_string4.replace('%TOTAL%', RoundFixed(parseInt(initial) + parseFloat(comission), 0));
			$(infoLine4).html( new_text );
			
			// set all prolong related data
			var new_text = options.prolong_line1.replace('%PROLONG1%', prolong1);
			$(prolongLine1).html( new_text );
			
			var new_text = options.prolong_line2.replace('%PROLONG2%', prolong2);
			$(prolongLine2).html( new_text );
			
			var new_text = options.prolong_line3.replace('%PROLONG3%', prolong3);
			$(prolongLine3).html( new_text );
			
			var submitButton = $(wrapper).find(".rateCalc_SubmitButton");
			var new_submit_text = options.submit_string.replace('%INITIAL%', initial);
			
			$(submitButton).html( new_submit_text );
		}
		
		function check_the_sum_is_right ( event )
		{
			var target_slder = $(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit");
			var slider = $(event.target).parent().parent().parent().find(".rateCalc_SliderInit");
			if ($(slider).hasClass('days'))
			{
				summ = $("#sum_input").val();
				
				if (summ <  options.min_sum) $("#sum_input").val(options.min_sum);			
				if (summ >  options.max_sum) $("#sum_input").val(options.max_sum);
				
				summ = $("#sum_input").val();
				
				if (((summ) % options.sum_step) != 0)
					
					$("#sum_input").val(parseInt(summ - ((summ) % options.sum_step)));
				
				$(target_slder).slider( 'value', summ );
			}
			
		}

		function select_max_value ( event )
		{
			var ClickedSlider = $(event.target).parent().find(".rateCalc_SliderInit");
			if ($(ClickedSlider).hasClass('days'))
			{
				var target_slder = $(obj).find(".rateCalc_DayBody_Slider_SliderBody .rateCalc_SliderInit");
				$(target_slder).slider( 'value', options.max_days );
				$("#days_input").val(options.max_days);
			}
			if ($(ClickedSlider).hasClass('sum'))
			{
				var target_slder = $(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit");
				$(target_slder).slider( 'value', options.max_sum );
				$("#sum_input").val(parseInt(options.max_sum));
			}	
			update_info_line(ClickedSlider);
		}

		function select_min_value ( event )
		{
			var ClickedSlider = $(event.target).parent().find(".rateCalc_SliderInit");
			if ($(ClickedSlider).hasClass('days'))
			{
				var target_slder = $(obj).find(".rateCalc_DayBody_Slider_SliderBody .rateCalc_SliderInit");
				$(target_slder).slider( 'value', options.min_days );
				$("#days_input").val(options.min_days);
			}
			if ($(ClickedSlider).hasClass('sum'))
			{
				var target_slder = $(obj).find(".rateCalc_SumBody_Slider_SliderBody .rateCalc_SliderInit");
				$(target_slder).slider( 'value', options.min_sum );
				$("#sum_input").val(parseInt(options.min_sum));
			}			
			update_info_line(ClickedSlider);
		}
		
		function disableEnterKey(e)
		{
		     var key;

		     if(window.event)
		          key = window.event.keyCode;     //IE
		     else
		          key = e.which;     //firefox

		     if(key == 13){
		    	 update_slider(e);
		         return false;
		     }
		     else
		          return true;
		}
		
		function select_all(e)
		{
			(e.target).focus();
			(e.target).select();
		}
		
		function check_int_value( event )
		{			
			var slider = $(event.target).parent().parent().find(".rateCalc_SliderInit");
			if ($(slider).hasClass('sum'))
			{
				var new_val = event.target.value;
				var test_result = /^\d+$/.test(new_val);
				if ( !test_result )				
					event.target.value = $(slider).slider('value')
				/*else
				{
					if (new_val > 5)
						if (((new_val) % 5) != 0)
							event.target.value = parseInt(new_val - ((new_val) % 5));
				}*/
			}
				else
					update_slider( event ); // for the days 
		}
		
		function update_slider( event )
		{
			var new_val = parseInt(event.target.value);
			var slider = $(event.target).parent().parent().find(".rateCalc_SliderInit");
			
			if ($(slider).hasClass('sum'))
			{
				if (new_val > options.sum_step)
					if (((new_val) % options.sum_step) != 0)
						new_val = parseInt(new_val - ((new_val) % options.sum_step));
			}
			
			var max_val = $(slider).slider("option", "max");
			var min_val = $(slider).slider("option", "min");
			

			if( !new_val )
				new_val = min_val;
			
			if( new_val > max_val )
			{
				new_val = max_val;
			}
			else if( new_val < min_val )
			{
				new_val = min_val;
			}
			
			event.target.value = new_val;
			
			$(slider).slider( 'value', new_val );
			
			update_info_line( event.target );
		}
		
		function sumbit_loan(e)
		{
			summ = $("#sum_input").val();
			
			if (summ <  options.min_sum) $("#sum_input").val(options.min_sum);			
			if (summ >  options.max_sum) $("#sum_input").val(options.max_sum);
			
			summ = $("#sum_input").val();
			
			if (((summ) % options.sum_step) != 0)
				
				$("#sum_input").val(parseInt(summ - ((summ) % options.sum_step)));
			
			document.forms['loanForm'].submit();
		}
		
		function increment_slider( e, src)
		{
			
			if (e != 0) target = e.target; else target = src;
			
			var slider = $(target).parent().parent().find(".rateCalc_SliderInit").slider('widget');
			var infoBox = $(target).parent().parent().find(".sliderInfo");
			
			var step = 1;
			if( $(slider).hasClass('sum') )
				step = options.sum_step;
			else if( $(slider).hasClass('days') )
				step = options.day_step;
			
			var current_val = $(slider).slider('value');
			$(slider).slider('value', current_val + step);
			
			var updated_value = $(slider).slider('value');
			
			$(infoBox).val( updated_value );
			
			update_info_line( $(slider) );
		}
		
		function decrement_slider( e, src )
		{
			if (e != 0) target = e.target; else target = src;
			
			var slider = $(target ).parent().parent().find(".rateCalc_SliderInit").slider('widget');
			var infoBox = $(target ).parent().parent().find(".sliderInfo");
			
			var step = 1;
			if( $(slider).hasClass('sum') )
				step = options.sum_step;
			else if( $(slider).hasClass('days') )
				step = options.day_step;
			
			var current_val = $(slider).slider('value');
			$(slider).slider('value', current_val - step);
			
			var updated_value = $(slider).slider('value');
			
			$(infoBox).val( updated_value );
			
			update_info_line( $(slider) );
		}
		
		
		function initToolTip( method, contracts )
		{
			$(toolTip).html( "Līdz : " + contracts );
			
			var disp = $(toolTip).css("display");
			
			if( !disp )
				$(toolTip).css("display", "none");
			
			if( method == 'hide' && disp != 'none' )
			{
				$(toolTip).css("display", "none");
			}
			else if( method == 'show' && disp == 'none' )
			{
				$(toolTip).css("display", "block");
			}
			else if( method == 'show' && disp != "none" )
			{
				var pos = $(toolTip).parent().find('.ui-slider-handle').offset();
				var self_pos = $(toolTip).offset();
				
				var width = $(toolTip).width();
				var height = $(toolTip).height();
				
				$(toolTip).css({'left': (pos.left)});
			}
			
		}
		
		function generate_body( obj )
		{
			//if (options.logged_in)
			$(obj).append('<div class="rateCalc_Body" style="background: url(\'/style/viasms/rateCalc/img/calc_bg.png\') no-repeat left top;"></div><div id="test"></div>');
			
			//else				
			//$(obj).append('<div id="calc_tabs" style="margin:0; padding:0; border:none;"><ul style="padding-left:35px;background:none;border:none;"><li  style="height:25px;font-weight:bold;"><a href="#tabs-1" id="c_tab_1">'+options.tab_hints[0]+'</a></li><li  style="height:25px;font-weight:bold;"><a href="#tabs-1" id="c_tab_2">'+options.tab_hints[1]+'</a></li><li  style="height:25px;font-weight:bold;"></ul><div id="tabs-1" style="margin:0; padding:0; border:none;"><div class="rateCalc_Body" style="background: url(\'/js/rateCalc/calc_bg.png\') no-repeat left top;"></div><div id="test"></div></div>');

			var calcBody = $(obj).find(".rateCalc_Body");
			
			$(calcBody).append('<table class="rateCalc_SumBody" border="0" style="width:920px;"  ></table>');
			//$(calcBody).append('<table class="rateCalc_DayBody" width="100%"></table>');
			
			var rateCalc_SumBody = $(calcBody).find(".rateCalc_SumBody");
			var rateCalc_DayBody = $(calcBody).find(".rateCalc_SumBody");
			
			var infoTable = 
			"<table class='infoTable'" +
					"<tr>" +
						"<td style='font-size: 13px; text-align:center; padding-top: 16px; padding-right:6px;'>" +
							'<div class="rateCalc_InfoLine1">' + options.sum_hints[0] + '</div>'+
						"</td>" +
					"</tr>" +
					"<tr>" +
						"<td style='font-size: 12px; text-align:center;'>" +
						 '<div class="rateCalc_InfoLine2">' + '' + '</div>'+
						"</td>" +
					"</tr>" +
					"<tr>" +
						"<td style='font-size: 16px; text-align:center; padding-top: 12px;'>" +
						'<div class="rateCalc_InfoLine3">' + '' + '</div>'+
						"</td>" +
					"</tr>" +
					"<tr>" +
						"<td style='font-size: 34px; font-family:Impact; font-weight: normal; text-align:left; padding-top: 8px; padding-left:80px;'>" +
						'<div class="rateCalc_InfoLine4">' + '' + '</div>'+
						"</td>" +
					"</tr>" +					
			"</table>";
			
			var prolongTable = 
				"<table class='prolongTable'" +
						"<tr>" +
							"<td style='font-size: 17px; text-align:left;padding-bottom:19px; padding-left:87px;letter-spacing:-1px;'>" +
								'<div class="rateCalc_prolongLine1">' + options.prolong_line1 + '</div>'+
							"</td>" +
						"</tr>" +
						"<tr>" +
							"<td style='font-size: 17px; text-align:left;padding-bottom:15px; padding-left:87px;letter-spacing:-1px;'>" +
							 '<div class="rateCalc_prolongLine2">' + options.prolong_line2 + '</div>'+
							"</td>" +
						"</tr>" +
						"<tr>" +
							"<td style='font-size: 17px; text-align:left; padding-bottom:7px; padding-left:87px;letter-spacing:-1px;'>" +
							'<div class="rateCalc_prolongLine3">' + options.prolong_line3 + '</div>'+
							"</td>" +
						"</tr>" +				
				"</table>";
			
			var stamp = "<div style='position:relative;z-index:100;'><div id = 'stamp'></div></div>";
			var shift_sum ='top:1px';
			var shift_days ='top:3px';
			
			if ((navigator.userAgent).indexOf('Firefox') != -1) {shift_sum='top:-1px;'; shift_days='top:2px;';};
			if ((navigator.userAgent).indexOf('MSIE') != -1) 	{shift_sum='top:1px;'; shift_days='top:3px;';};
			
			
			$(rateCalc_SumBody).append('<tr><td class="rateCalc_SumBody_Description" colspan="5">' + options.description_sum + '</td><td valign="top" rowspan="6" style="padding-left:20px;">' + infoTable + '<div class="rateCalc_Submit"><a href="#" class="rateCalc_SubmitButton">' + options.submit_string + '</a></div></td><td rowspan="6" valign="bottom">' + prolongTable /*+  stamp */+'</td></tr>');
			$(rateCalc_SumBody).append('<tr><td class="rateCalc_SumBody_Subtext rateCalc_FontSmall" colspan="5">' + options.subtext_sum + '</td></tr>');
			$(rateCalc_SumBody).append('<tr class="rateCalc_SumBody_SliderTr"></tr>');
			
			var rateCalc_SumBody_SliderTr = $(rateCalc_SumBody).find("tr.rateCalc_SumBody_SliderTr"); 
			$(rateCalc_SumBody_SliderTr).append('<td style="padding-left:10px;" class="rateCalc_SumBody_Slider_Decrement"><a id="sminus" class="decrement" href="#">&nbsp;</a></td>');
			$(rateCalc_SumBody_SliderTr).append('<td class="rateCalc_SumBody_Slider_SliderBody" style="height:56px;"><div class="LeftSliderAddon"></div><div class="RightSliderAddon"></div><div class="rateCalc_SliderInit sum"></div></td>');
			$(rateCalc_SumBody_SliderTr).append('<td class="rateCalc_SumBody_Slider_Increment"><a id="splus" class="increment" href="#">&nbsp;</a></td>');
			$(rateCalc_SumBody_SliderTr).append('<td style="align:center;padding-left:2px;" valign="center" class="rateCalc_SumBody_Slider_Info"><input id = "sum_input" name="sum" style="position:relative; '+ shift_sum +'" class="sliderInfo" type="text" value="'+options.default_sum+'" /></td>');
			
			
			$(rateCalc_DayBody).append('<tr><td class="rateCalc_DayBody_Description" colspan="5">' + options.description_day + '</td></tr>');
			$(rateCalc_DayBody).append('<tr><td class="rateCalc_DayBody_Subtext rateCalc_FontSmall" colspan="5">' + options.subtext_day + '</td></tr>');
			$(rateCalc_DayBody).append('<tr class="rateCalc_DayBody_SliderTr"></tr>');
			
			var rateCalc_DayBody_SliderTr = $(rateCalc_DayBody).find("tr.rateCalc_DayBody_SliderTr"); 
			$(rateCalc_DayBody_SliderTr).append('<td style="padding-left:10px;" class="rateCalc_DayBody_Slider_Decrement"><a id="dminus" class="decrement" href="#">&nbsp;</a></td>');
			$(rateCalc_DayBody_SliderTr).append('<td class="rateCalc_DayBody_Slider_SliderBody" style="height:70px;"><div class="LeftSliderAddon"></div><div class="RightSliderAddon"></div><div class="rateCalc_SliderInit days"></div></td>');
			$(rateCalc_DayBody_SliderTr).append('<td class="rateCalc_DayBody_Slider_Increment"><a id="dplus" class="increment" href="#">&nbsp;</a></td>');
			$(rateCalc_DayBody_SliderTr).append('<td style="align:center;padding-left:2px;" valign="center" class="rateCalc_DayBody_Slider_Info"><input id = "days_input" name="days" style="position:relative; '+ shift_days +'" class="sliderInfo" type="text" value="'+options.default_days+'" /></td>');
			
			//$(calcBody).append('<div class="rateCalc_InfoLine">' + options.info_line_string + '</div><div class="rateCalc_Submit"><a href="javascript:;" class="rateCalc_SubmitButton">' + options.submit_string + '</a></div><div class="cls"></div>')
		}
		
		function inspect(obj, maxLevels, level)
		{
		  var str = '', type, msg;

		    // Start Input Validations
		    // Don't touch, we start iterating at level zero
		    if(level == null)  level = 0;

		    // At least you want to show the first level
		    if(maxLevels == null) maxLevels = 1;
		    if(maxLevels < 1)     
		        return '<font color="red">Error: Levels number must be > 0</font>';

		    // We start with a non null object
		    if(obj == null)
		    return '<font color="red">Error: Object <b>NULL</b></font>';
		    // End Input Validations

		    // Each Iteration must be indented
		    str += '<ul>';

		    // Start iterations for all objects in obj
		    for(property in obj)
		    {
		      try
		      {
		          // Show "property" and "type property"
		          type =  typeof(obj[property]);
		          str += '<li>(' + type + ') ' + property + 
		                 ( (obj[property]==null)?(': <b>null</b>'):('')) + '</li>';

		          // We keep iterating if this property is an Object, non null
		          // and we are inside the required number of levels
		          if((type == 'object') && (obj[property] != null) && (level+1 < maxLevels))
		          str += inspect(obj[property], maxLevels, level+1);
		      }
		      catch(err)
		      {
		        // Is there some properties in obj we can't access? Print it red.
		        if(typeof(err) == 'string') msg = err;
		        else if(err.message)        msg = err.message;
		        else if(err.description)    msg = err.description;
		        else                        msg = 'Unknown';

		        str += '<li><font color="red">(Error) ' + property + ': ' + msg +'</font></li>';
		      }
		    }

		      // Close indent
		      str += '</ul>';

		    return str;
		}
		
			
		function RoundFixed(Number, DecimalPlaces) {
		   return Round(Number, DecimalPlaces).toFixed(DecimalPlaces);
		}
		
		function Round(Number, DecimalPlaces) {
		   return Math.round(parseFloat(Number) * Math.pow(10, DecimalPlaces)) / Math.pow(10, DecimalPlaces);
		}
		
	}
})(jQuery);